/*
 * test_permutations.cpp
 *
 *  Created on: Aug 12, 2015
 *      Author: dave
 */

#include <iostream>
#include <chrono>
#include "misc.h"
#include "timer.h"


using namespace tst;
using namespace std;

static int n_min, n_max;

static int parse_args(int argc, char **argv)
{
	switch (argc)
	{
		case 2:
			n_min = n_max = atoi(argv[1]);
			break;
		case 3:
			n_min = atoi(argv[1]);
			n_max = atoi(argv[2]);
			break;
		default:
			printf("\nUsage: %s n [n-max]\n\n"
					"\tn: (n-min) length of the string to permute\n"
					"\tn-max: maximim length of the string to permute, starting from n-min\n\n",
					argv[0]);
			return -1;
	}

	// adjust
	if (n_min < 1)
		n_min = 1;
	if (n_max < n_min)
		n_max = n_min;

	printf("\nPermute L\n");
	if (argc == 2)
		printf("\tn: %d\n", n_min);
	else
	{
		printf("\tn-min: %d\n", n_min);
		printf("\tn-max: %d\n", n_max);
	}
	printf("\n");

	return 0;
}


long long g_perms;

template <typename T>
static void visit_count(const T begin, const T end)
{
	g_perms++;
	visit_show(begin, end);
}


int main(int argc, char **argv)
{
	if (parse_args(argc, argv) != 0)
		return 1;

	FILE *fp = fopen("test_permute.csv", "w");

	// eventually fills the cache
	bool first = true;
restart:

	for (int n = n_min; n <= n_max; n++)
	{
		vector<int> a { 1,1,1,3 };
		//vector<int> a(n);
		//for (int i = 0; i < n; i++)
		//	a[i] = i;
		//for (int i = 0; i < n/2; i++)
		//	a[i] = 0;
		//for (int i = n/2; i < n; i++)
		//	a[i] = 1;


		g_perms = 0;

		timer t;
		auto start = t.get_ticks();
		visit_permutations(a.begin(), a.end(), visit_count);
		auto stop = t.get_ticks();
		double delta = (stop - start) / 1000000.0;

        if (first)
        {
        	first = false;
			goto restart;
		}

		// print to file
		fprintf(fp, "%d,%lld,%f\n", n, g_perms, delta);
		// print to standard output
		printf("> n: %d, perms: %lld, time: %f\n\n", n, g_perms, delta);
	}

	fclose(fp);
}
